(function () {
    const magnet = new RegExp('magnet:\\?xt=urn:btih:\\w{10,}([-a-zA-Z0-9()@:%_\\+.~#?&//=]*)', 'gim');
    const http = /https?:\/\/[^\s"']+/gim;
   // const http = new RegExp('(https?:\\/\\/)(([0-9a-z.]+\\.[a-z]+)|(([0-9]{1,3}\\.){3}[0-9]{1,3}))(:[0-9]+)?(\\/[0-9a-z%/.\\-_]*)?(\\?[0-9a-z=&%_\\-]*)?(\\#[0-9a-z=&%_\\-]*)?', 'gim');
    const ftp = new RegExp('(ftp?:\\/\\/)(([0-9a-z.]+\\.[a-z]+)|(([0-9]{1,3}\\.){3}[0-9]{1,3}))(:[0-9]+)?(\\/[0-9a-z%/.\\-_]*)?(\\?[0-9a-z=&%_\\-]*)?(\\#[0-9a-z=&%_\\-]*)?', 'gim');
    
    // ======================= ed2k ==============================
    // 原来的（问题在于 第一个 ？ 号 和 ｜ 没有转移，导致语法变成了 “或”）：
    // const ed2k = new RegExp('(ed2k?:\\/\\/|file|)(.+|)\\/', 'gim');
    
    // 改进的:
    // https://zhidao.baidu.com/question/2141578588911342228.html
    const ed2k = /ed2k:\/\/\|file\|[^ ]+\|\//gim;
    
    const thunder = new RegExp('(thunder?:\\/\\/)([a-zA-Z0-9]+=+)', 'gim');
    const xunlei = new RegExp('(http|https)://pan.xunlei.com/s/[0-9a-zA-Z-_]{8,30}([\\s\\S]{0,20}(访问码|提取码|密码|)[\\s\\S]{0,10}[0-9a-zA-Z]{4}|)', 'gim');

    var working = false;
    function work() {
        if (document.documentElement == null) {
            return;
        }

        if (working) {
            return
        }

        working = true;
        console.log('work');

       
        // 原来的（问题在于每次都要提取一次 document.documentElement.outerHTML，应该要缓存起来。而且其实只需要 body，不需要 head）：
        // var m = document.documentElement.outerHTML.match(magnet);
        // var h = document.documentElement.outerHTML.match(http);
        // var f = document.documentElement.outerHTML.match(ftp);
        // var e = document.documentElement.outerHTML.match(ed2k);
        // var t = document.documentElement.outerHTML.match(thunder);
        // var x = document.documentElement.outerHTML.match(xunlei);

        // 改进的 (利用缓存)：
        var bodyStr = document.body.innerHTML;

        var m = bodyStr.match(magnet);
        var h = bodyStr.match(http);
        var f = bodyStr.match(ftp);
        var e = bodyStr.match(ed2k);
        var t = bodyStr.match(thunder);
        var x = bodyStr.match(xunlei);
        
        // 改进的：拿到所有数据后，一次性交给客户端，不要频繁调用通讯接口
        var retArr = [];
        
        if (m != null) {
            for (var i = 0; i < m.length; ++i) {
                // 改进的：
                retArr.push(m[i]);
                
                // 原来的：
                // XWebViewApi.call('addURL', m[i], 'browser', 'this');
            }
        }

        if (h != null) {
            for (var i = 0; i < h.length; ++i) {
                // 改进的：
                retArr.push(h[i]);
                
                // 原来的：
                // XWebViewApi.call('addURL', h[i], 'browser', 'this');
            }
        }

        if (f != null) {
            for (var i = 0; i < f.length; ++i) {
                // 改进的：
                retArr.push(f[i]);
                
                // 原来的：
                // XWebViewApi.call('addURL', f[i], 'browser', 'this');
            }
        }

        if (e != null) {
            for (var i = 0; i < e.length; ++i) {
                // 改进的：
                retArr.push(e[i]);
                
                // 原来的：
                // XWebViewApi.call('addURL', e[i], 'browser', 'this');
            }
        }

        if (t != null) {
            for (var i = 0; i < t.length; ++i) {
                // 改进的：
                retArr.push(t[i]);
                
                // 原来的：
                // XWebViewApi.call('addURL', t[i], 'browser', 'this');
            }
        }

        if (x != null) {
            for (var i = 0; i < x.length; ++i) {
                // 改进的：
                var u = x[i].replace(/\s*(访问码|提取码|密码)[\s\S]{0,10}([0-9a-zA-Z]{4})/gi, '?pwd=$2')
                retArr.push(u);
                
                // 原来的：
                // var u = x[i].replace(/\s*(访问码|提取码|密码)[\s\S]{0,10}([0-9a-zA-Z]{4})/gi, '?pwd=$2')
                // XWebViewApi.call('addURL', u, 'browser', 'this');
            }
        }
        
        working = false;
        
        var newRetArr = [...new Set(retArr)]; // 去重
        
        // TODO: 怎么把数组给到客户端 @王鹏 下面的 newAddURLArr 是我随意填写的
        XWebViewApi.call('addURLs', newRetArr, 'browser', 'this');
    }

    XWebViewApi.registerCommand('sniffPageURL', work);
    /*function watchBodyChange(onchange) {
        let timeout;
        let observer = new MutationObserver(() => {
            if (!timeout) {
                timeout = setTimeout(() => {
                    timeout = null;
                    onchange();
                }, 200);
            }
        });
        observer.observe(document.documentElement, {
            childList: true,
            subtree: true,
            attributes: true,
            characterData: true
        });
    }

    function whenDOMReady(f) {
        if (document.body) f();
        else window.addEventListener("DOMContentLoaded", f);
    }

    whenDOMReady(() => {
        watchBodyChange(work);
    });*/
})();