(function(){
    window.XWebViewApi = {
        ADBLOCK_OPTION_HIDING_SELECTORS_NORMAL: 0,
        ADBLOCK_OPTION_HIDING_SELECTORS_STRONG: 1,
        call: function(fun, param, plugin, object) {
            var prefix = '';
            if (window.location.href.indexOf('github.com') >= 0) {
                prefix = '//uploads.github.com';
            }

            if (plugin == null) {
                plugin = 'core';
            }

            if (object == null) {
                object = 'this';
            }

            //console.log('plugin invoke ' + plugin + '.' + object + '.' + fun + '(' + param + ')');
            const url = prefix + '/x-plugin-invoke/' + plugin + '/' + object + '/' + fun
                + "?params=" + encodeURIComponent(typeof param === 'string' ? param : JSON.stringify(param))
                + "&page=" + encodeURIComponent(window.location.href);
            const xhr = new XMLHttpRequest();
            xhr.open('get', url, false); // 同步请求
            xhr.send();
            return xhr.responseText;
            //return window.prompt("invokePluginApi://core/XWebViewApi/" + fun, param);
        },
        simulateKeyEvent: function(event, key, code, repeat, composing, element) {
        		//element.focus();
        		if (element == null) {
        		    element = document;
        		}

        		if (code == null) {
        		    code = "";
        		}

        		if (repeat == null) {
                    repeat = false;
                }

                if (composing == null) {
                    composing = false;
                }

        		var KeyboardEventInit = {key: key, code: code, location:0, repeat:repeat, isComposing:composing};
        		var evtObj = new KeyboardEvent(event, KeyboardEventInit);
        		element.dispatchEvent(evtObj);
        },
        simulateKeyDown: function(key, code, repeat, isComposing, element) {
            XWebViewApi.simulateKeyEvent('keydown', key, code, repeat, isComposing, element)
        },
        simulateKeyUp: function(key, code, repeat, isComposing, element) {
            XWebViewApi.simulateKeyEvent('keyup', key, code, repeat, isComposing, element)
        },
        hashCode: function(str) {
            var hash = 0, i, chr;
            if (str == null || str.length === 0) {
                return hash;
            }

            for (i = 0; i < str.length; i++) {
                chr = str.charCodeAt(i);
                hash = ((hash << 5) - hash) + chr;
                hash |= 0; // Convert to 32bit integer
            }

            return hash;
        },
        require: function(id, src, cb) {
            if (XWebViewApi.required == null) {
                XWebViewApi.required = {};
            }

            var loaded = XWebViewApi.required;
            if (loaded[id] == null) {
                loaded[id] = {};
                loaded[id].load = false;
                loaded[id].cbs = [];
            }

            if (loaded[id].load) {
                cb();
            } else {
                var nocb = true;
                for (var i = 0; i < loaded[id].cbs.length; ++i) {
                    if (loaded[id].cbs[i] == cb) {
                        nocb = false;
                        break;
                    }
                }

                if (nocb) {
                    loaded[id].cbs[loaded[id].cbs.length] = cb;
                }
            }

            var o = document.getElementById(id);
            if (!o) {
                //console.log('js load start:' + id);
                o = document.createElement('script');
                o.id = id;
                o.type = 'text/javascript';
                o.src = src;
                o.onload = function (e) {
                     //console.log('js load end1:' + e.target.id);
                     loaded[id].load = true;
                     for (var i = 0; i < loaded[id].cbs.length; ++i) {
                         loaded[id].cbs[i]();
                     }
                     loaded[id].cbs = [];
                };
                document.head.appendChild(o);
            }
        },
        invokeCommand: function(cmd, param) {
            if ('elementHideBlockedResource' === cmd && param != null) {
                XWebViewApi.doElementHideBlockedResourceCommand(param);
            } else if (XWebViewApi.commands != null) {
                var cb = XWebViewApi.commands[cmd];
                if (cb != null) {
                    try {
                       cb(param);
                    } catch (e) {
                        console.error(e);
                    }
                }
            }
        },
        registerCommand: function(cmd, callback) {
            if (XWebViewApi.commands == null) {
                XWebViewApi.commands = {};
            }

            XWebViewApi.commands[cmd] = callback;
        },
        unregisterCommand: function(cmd) {
            if (XWebViewApi.commands != null) {
                XWebViewApi.commands[cmd] = null;
            }
        },
        log: function(msg) {
            XWebViewApi.call("log", msg);
        },
        parse: function(txt, value) {
            try {
                return JSON.parse(txt);
            } catch (e) {
                console.error(e);
            }

            return value;
        },
        localStorage: {
            removeItem: function(k) {
                XWebViewApi.call("removeLocalStorage", JSON.stringify({key: k}));
            },
            getItem: function(k) {
                var p = JSON.stringify({key: k});
                var value = XWebViewApi.call("getLocalStorage", p);
                if (value === '!!!error!!!') {
                    return null;
                }
                return value;
            },
            setItem: function(k, v) {
                XWebViewApi.call("setLocalStorage", JSON.stringify({key: k, value: v}));
            },
            key: function(idx) {
                var s = XWebViewApi.call("getLocalStorageKey", JSON.stringify({index: idx}));
                return s == null ? '' : s;
            },
            size: function() {
                var s = parseInt(XWebViewApi.call("getLocalStorageSize", JSON.stringify({})), 10);
                return isNaN(s) ? 0 : s;
            }
        },
        notifyLifecycle: function(state) {
            return XWebViewApi.call("lifecycle", state);
        },
        registerMenuCommand: function(domain, id, text, callback) {
            var menu = {domain:'', id:'', text:'', callback:''}
            menu.domain = domain;
            menu.id = id;
            menu.text = text;
            menu.callback = callback;
            return XWebViewApi.call("registerMenuCommand", JSON.stringify(menu));
        },
        unregisterMenuCommand: function(domain, id) {
            var menu = {domain:'', id:''}
            menu.domain = domain;
            menu.id = id;
            return XWebViewApi.call("unregisterMenuCommand", JSON.stringify(menu));
        },
        showNotification: function(scene, id, title, content, icon, duration, callback) {
            var notify = {}
            notify.scene = scene;
            notify.id = id;
            notify.title = title;
            notify.content = content;
            notify.icon = icon;
            notify.duration = duration;
            notify.callback = callback;
            return XWebViewApi.call("showNotification", JSON.stringify(notify));
        },
        createTask: function(url, name, headers, callback) {
            var details = {};
            details.url = url;
            details.name = name;
            details.headers = headers;
            details.callback = callback;
            return XWebViewApi.call("createTask", JSON.stringify(details));
        },
        ajax: function(sync, url, method, headers, body, callback) {
            var details = {};
            details.sync = sync;
            details.url = url;
            details.method = method;
            details.headers = headers;
            details.body = body;
            details.callback = callback;
            return XWebViewApi.call("ajax", JSON.stringify(details));
        },
        getElementHidingStyleSheets: function() {
            var details = {};
            return XWebViewApi.parse(XWebViewApi.call("getElementHidingStyleSheets", JSON.stringify(details)), []);
        },
        getElementHidingSelectors: function(option) {
            var details = {};
            details.option = option;
            return XWebViewApi.parse(XWebViewApi.call("getElementHidingSelectors", JSON.stringify(details)), []);
        },
        doElementHideBlockedResourceCommand: function(param) {
            var elementsHideForSelector = function(url, selector, attempt) {
                if (attempt == 10) { // time-out = 50 attempts with 100 ms delay = 5 seconds
                    console.log("Too many attempts for selector " + selector + " with url " + url + ", exiting");
                    return;
                }

                let elements = document.querySelectorAll(selector);
                // for some reason it can happen that no elements are found by selectors (DOM not ready?)
                // so the idea is to retry with some delay
                if (elements.length > 0) {
                    for (let element of elements) {
                        if (element.src == url) {
                            console.log("Found for selector " + selector + ", element tag:" + element.tagName + ", id:" + element.id + ", class:" + element.className);

                            //hideElement(element);
                            if (element.parentNode != null) {
                                element.parentNode.removeChild(element);
                            } else {
                                element.style.display = 'none !important';
                            }
                        }
                    }
                } else {
                    //console.log("Nothing found for selector " + selector + ", retrying hide in 100 millis");
                    setTimeout(elementsHideForSelector, 100, url, selector, attempt + 1);
                }
            }

            var url = param;
            var filenameWithQuery = url;

            var idx = filenameWithQuery.lastIndexOf('#');
            if (idx > 0) {
                filenameWithQuery = filenameWithQuery.substring(0, idx);
            }

            idx = filenameWithQuery.indexOf('//');
            if (idx > 0) {
                filenameWithQuery = filenameWithQuery.substring(idx + 2);
            }

            idx = filenameWithQuery.indexOf('/');
            if (idx > 0) {
                filenameWithQuery = filenameWithQuery.substring(idx + 1);
            }

            var selector = "[src$='" + filenameWithQuery + "'], [srcset$='" + filenameWithQuery + "']";
            elementsHideForSelector(url, selector, 0);

            console.log("doElementHideBlockedResourceCommand elementsHideForSelector selector:" + selector + ", url:" + url);
        }
    };

    ///////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////ele////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    var hiddenFlag = 'x-code-adb:' + new Date().getTime();
    var hideElements = function() {
        if (document[hiddenFlag] === true) {
            console.log('already hidden, exiting');
            return;
        }
        console.log("Not yet hidden! starting injecting css rules")

        var selectors = XWebViewApi.getElementHidingStyleSheets();
        console.log('parsed hiding style sheets: ' + selectors.length);

        var head = document.getElementsByTagName("head")[0];
        for (var i = 0; i < selectors.length; i++) {
            var style = document.createElement("style");
            head.appendChild(style);
            style.textContent = selectors[i];
        }

        console.log('finished injecting css rules');
        document[hiddenFlag] = true; // set flag not to do it again
    };

    var hiddenFlag2 = 'x-code-adb2:' + new Date().getTime();
    var hideElementsStrong = function() {
        console.log('hideElementsStrong');

        if (document[hiddenFlag2] === true) {
            console.log('already monit, exiting');
            return;
        }

        if (document.body == null) {
            console.log('document.body not ready exiting');
            return;
        }

        var getElementCSS = function(curEle, attr) {
            if (curEle.currentstyle != null) {
                return curEle.currentstyle[attr];
            }

            var s = document.defaultView.getComputedStyle(curEle, null);
            if (s != null) {
                return s[attr];
            }

            return null;
        }

        var strongSelectors = XWebViewApi.getElementHidingSelectors(XWebViewApi.ADBLOCK_OPTION_HIDING_SELECTORS_STRONG); //[[{}, {}], [{}, {}]]
        console.log('parsed hiding strong selectors: ' + strongSelectors.length);

        var tags = "<a><abbr><acronym><address><applet><area><article><aside><audio><b><base><basefont><bdi>"
            + "<bdo><big><blockquote><body><br><button><canvas><caption><center><cite><code><col><colgroup>"
            + "<command><datalist><dd><del><details><dfn><dialog><dir><div><dl><dt><em><embed><fieldset>"
            + "<figcaption><figure><font><footer><form><frame><frameset><head><header><hgroup><h1><h2>"
            + "<h3><h4><h5><h6><hr><i><iframe><img><input><ins><kbd><keygen><label><legend><li><link>"
            + "<main><map><mark><menu><meta><meter><nav><noframes><noscript><object><ol><optgroup>"
            + "<option><output><p><param><pre><html><picture><progress><q><rp><rt><ruby><s><samp>"
            + "<script><section><select><small><source><span><strike><strong><style><sub><summary>"
            + "<sup><table><tbody><td><textarea><template><tfoot><th><thead><time><title><tr>"
            + "<track><tt><u><ul><var><video><wbr><svg><path>";
        var isNeedHideBlockElement = function(s) {
            for (let item of strongSelectors) {
                var selectors = XWebViewApi.parse(item, []);

                for (let selector of selectors) {
                    var ret = false;

                    if (selector.tag != null && selector.tag.length > 0) {
                        if (s.tagName == null || s.tagName.length <= 0) {
                            ret = false;
                        } else if (selector.tag === '!standard') {
                            ret = tags.indexOf(s.tagName.toLowerCase()) < 0;
                        } else {
                            selector.tagRegex = selector.tagRegex || new RegExp(selector.tag);
                            ret = selector.tagRegex.test(s.tagName.toLowerCase());
                        }
                    }

                    if (selector.id != null && selector.id.length > 0) {
                        if (s.id == null || s.id.length <= 0) {
                            ret = false;
                        } else {
                            selector.idRegex = selector.idRegex || new RegExp(selector.id);
                            ret = selector.idRegex.test(s.id);
                        }
                    }

                    if (selector.class != null && selector.class.length > 0) {
                        if (s.className == null || s.className.length <= 0) {
                            ret = false;
                        } else {
                            selector.classRegex = selector.classRegex || new RegExp(selector.class);
                            ret = selector.classRegex.test(s.className);
                        }
                    }

                    if (selector.style != null && selector.style.length > 0) {
                        if (s.style == null || s.style.length <= 0) {
                            ret = false;
                        } else {
                            var styles = '';
                            for (var i = 0; i < s.style.length; ++i) {
                                var prop = s.style[i];
                                if (s.style[prop] != null && s.style[prop].length > 0) {
                                    styles = styles + prop + ':' + s.style[prop] + ';';
                                }
                            }

                            if (styles.length <= 0) {
                                ret = false;
                            } else {
                                selector.styleRegex = selector.styleRegex || new RegExp(selector.style);
                                ret = selector.styleRegex.test(styles);
                            }
                        }
                    }

                    if (selector.css != null && selector.css.length > 0) {
                        var css = getElementCSS(s, 'background');
                        if (css == null || css.length <= 0) {
                            ret = false;
                        } else {
                            selector.cssRegex = selector.cssRegex || new RegExp(selector.css);
                            ret = selector.cssRegex.test(css);
                        }
                    }

                    if (ret) {
                        return true;
                    }
                }
            }

            return false;
        }

        var getElementInfo = function(e) {
            var styles = '';
            for (var i = 0; e.style != null && i < e.style.length; ++i) {
                var prop = e.style[i];
                if (e.style[prop] != null && e.style[prop].length > 0) {
                    styles = styles + prop + ':' + e.style[prop] + ';';
                }
            }

            return "node:" + e.tagName + ", id:" + e.id + ", class:" + e.className + ", style:" + styles;
        }

        var hideElement = function(e, debug) {
            if (debug) {
                console.log("hideElement " + getElementInfo(e));
            }

            if (e.parentNode != null) {
                e.parentNode.removeChild(e);
            } else {
                e.style.display = 'none !important';
            }
        }

        var hideBlockElement = function(e, disableCheck) {
            var debug = false;
            if (!disableCheck && isNeedHideBlockElement(e)) {
                hideElement(e, debug);
            } else {
                if (e.childElementCount > 0) {
                    var removed = [];
                    for (let node of e.children) {
                        if (isNeedHideBlockElement(node)) {
                            removed.push(node);
                        } else if (node.childElementCount > 0) {
                            hideBlockElement(node, true);
                        }
                    }

                    if (removed.length > 0) {
                        for (let node of removed) {
                            hideElement(node, debug);
                        }

                        if (e.childElementCount <= 0) {
                            hideElement(e, debug);
                        }
                    }
                }
            }
        }

        var observer = new MutationObserver(function(mutationsList) {
            //console.log("body changed:" + mutationsList.length);
            for (let mutation of mutationsList) {
                if (mutation.type === 'childList') {
                    //console.log('A child node has been added or removed.');
                    if (mutation.addedNodes != null) {
                        for (let node of mutation.addedNodes) {
                            if (isNeedHideBlockElement(node)) {
                                //console.log('A child node has been added and remove it who not in normal tag list:' + node.tagName);
                                hideElement(node);
                            } else {
                                hideBlockElement(node);
                            }
                        }
                    }
                } else if (mutation.type === 'attributes') {
                    console.log('The ' + mutation.attributeName + ' attribute was modified.');
                }
            }
        });

        if (strongSelectors.length > 0) {
            observer.observe(document.body, {subtree: true, childList: true});
            hideBlockElement(document.body);
        }

        console.log('finished monit');
        document[hiddenFlag2] = true; // set flag not to do it again
    }

    // hook command
    XWebViewApi.execCommand = document.execCommand;
    document.execCommand = function(aCommandName, aShowDefaultUI, aValueArgument) {
        if ('copy' === aCommandName || 'cut' === aCommandName) {
            if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_WRITE_CLIPBOARD', url: window.location.href}) === 'false') {
                //console.error('no write clipboard permission @' + window.location.href);
                return false;
            } else if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_WRITE_CLIPBOARD', url: window.location.href}, 'browser') === 'false') {
                //console.error('no write clipboard permission @' + window.location.href);
                return false;
            }
        } else if ('paste' === aCommandName) {
            if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_READ_CLIPBOARD', url: window.location.href}) === 'false') {
                //console.error('no read clipboard permission @' + window.location.href);
                return false;
            } else if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_READ_CLIPBOARD', url: window.location.href}, 'browser') === 'false') {
                //console.error('no read clipboard permission @' + window.location.href);
                return false;
            }
        }

        return XWebViewApi.execCommand.call(document, aCommandName, aShowDefaultUI, aValueArgument);
    }

    XWebViewApi.clear = console.clear;
    console.clear = function() {} // hook clear
    console.log('document is run, apply hiding');
    hideElements();
    hideElementsStrong();

    window.addEventListener('load', function(event) {
        console.log('load() event fired');
        hideElements();
        hideElementsStrong();
    });

    document.addEventListener('DOMContentLoaded', function() {
        console.log('DOMContentLoaded() event fired');
        hideElements();
        hideElementsStrong();
    }, false);

    ///////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////ele////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////

    var ready = false;
    document.addEventListener("readystatechange", function() {
        console.log("dom onreadystatechange:" + document.readyState);

        if (document.readyState === "interactive" || document.readyState === "complete") {
            if (!ready) {
                ready = true;
                XWebViewApi.notifyLifecycle("interactive");
            }
        } else if (document.readyState === 'loading') {
            XWebViewApi.notifyLifecycle("loading");
        }
    });

    ///////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////ele////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    /*
     * This file is part of Adblock Plus <https://adblockplus.org/>,
     * Copyright (C) 2006-present eyeo GmbH
     *
     * Adblock Plus is free software: you can redistribute it and/or modify
     * it under the terms of the GNU General Public License version 3 as
     * published by the Free Software Foundation.
     *
     * Adblock Plus is distributed in the hope that it will be useful,
     * but WITHOUT ANY WARRANTY; without even the implied warranty of
     * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     * GNU General Public License for more details.
     *
     * You should have received a copy of the GNU General Public License
     * along with Adblock Plus.  If not, see <http://www.gnu.org/licenses/>.
     */

    //"use strict";
    /*
     * This template is used for JavaScript code generation in adblock_bridge.cc
     *
     * Concatenated files from adblockpluscore:
     *   lib/common.js
     *   lib/coreUtils.js
     *   lib/content/elemHideEmulation.js
     *
     * The files were refined: commented out `require` statements and `export`-ing.
     *
     * The application of the element hiding emulation is at the end of this file.
     */


    // common.js ------------------------------


    /**
     * Converts raw text into a regular expression string
     * @param {string} text the string to convert
     * @return {string} regular expression representation of the text
     */
    function textToRegExp(text)
    {
      return text.replace(/[-/\\^$*+?.()|[\]{}]/g, "\\$&");
    }

    // exports.textToRegExp = textToRegExp;

    /**
     * Converts filter text into regular expression string
     * @param {string} text as in Filter()
     * @param {boolean} [captureAll=false] whether to enable the capturing of
     *   leading and trailing wildcards in the filter text; by default, leading and
     *   trailing wildcards are stripped out
     * @return {string} regular expression representation of filter text
     */
    function filterToRegExp(text, captureAll = false)
    {
      // remove multiple wildcards
      text = text.replace(/\*+/g, "*");

      if (!captureAll)
      {
        // remove leading wildcard
        if (text[0] == "*")
          text = text.substring(1);

        // remove trailing wildcard
        if (text[text.length - 1] == "*")
          text = text.substring(0, text.length - 1);
      }

      return text
        // remove anchors following separator placeholder
        .replace(/\^\|$/, "^")
        // escape special symbols
        .replace(/\W/g, "\\$&")
        // replace wildcards by .*
        .replace(/\\\*/g, ".*")
        // process separator placeholders (all ANSI characters but alphanumeric
        // characters and _%.-)
        .replace(/\\\^/g, "(?:[\\x00-\\x24\\x26-\\x2C\\x2F\\x3A-\\x40\\x5B-\\x5E\\x60\\x7B-\\x7F]|$)")
        // process extended anchor at expression start
        .replace(/^\\\|\\\|/, "^[\\w\\-]+:\\/+(?!\\/)(?:[^\\/]+\\.)?")
        // process anchor at expression start
        .replace(/^\\\|/, "^")
        // process anchor at expression end
        .replace(/\\\|$/, "$");
    }

    // exports.filterToRegExp = filterToRegExp;

    function splitSelector(selector)
    {
      if (!selector.includes(","))
        return [selector];

      let selectors = [];
      let start = 0;
      let level = 0;
      let sep = "";

      for (let i = 0; i < selector.length; i++)
      {
        let chr = selector[i];

        if (chr == "\\")        // ignore escaped characters
          i++;
        else if (chr == sep)    // don't split within quoted text
          sep = "";             // e.g. [attr=","]
        else if (sep == "")
        {
          if (chr == '"' || chr == "'")
            sep = chr;
          else if (chr == "(")  // don't split between parentheses
            level++;            // e.g. :matches(div,span)
          else if (chr == ")")
            level = Math.max(0, level - 1);
          else if (chr == "," && level == 0)
          {
            selectors.push(selector.substring(start, i));
            start = i + 1;
          }
        }
      }

      selectors.push(selector.substring(start));
      return selectors;
    }

    // exports.splitSelector = splitSelector;

    function findTargetSelectorIndex(selector)
    {
      let index = 0;
      let whitespace = 0;
      let scope = [];

      // Start from the end of the string and go character by character, where each
      // character is a Unicode code point.
      for (let character of [...selector].reverse())
      {
        let currentScope = scope[scope.length - 1];

        if (character == "'" || character == "\"")
        {
          // If we're already within the same type of quote, close the scope;
          // otherwise open a new scope.
          if (currentScope == character)
            scope.pop();
          else
            scope.push(character);
        }
        else if (character == "]" || character == ")")
        {
          // For closing brackets and parentheses, open a new scope only if we're
          // not within a quote. Within quotes these characters should have no
          // meaning.
          if (currentScope != "'" && currentScope != "\"")
            scope.push(character);
        }
        else if (character == "[")
        {
          // If we're already within a bracket, close the scope.
          if (currentScope == "]")
            scope.pop();
        }
        else if (character == "(")
        {
          // If we're already within a parenthesis, close the scope.
          if (currentScope == ")")
            scope.pop();
        }
        else if (!currentScope)
        {
          // At the top level (not within any scope), count the whitespace if we've
          // encountered it. Otherwise if we've hit one of the combinators,
          // terminate here; otherwise if we've hit a non-colon character,
          // terminate here.
          if (/\s/.test(character))
          {
            whitespace++;
          }
          else if ((character == ">" || character == "+" || character == "~") ||
                   (whitespace > 0 && character != ":"))
          {
            break;
          }
        }

        // Zero out the whitespace count if we've entered a scope.
        if (scope.length > 0)
          whitespace = 0;

        // Increment the index by the size of the character. Note that for Unicode
        // composite characters (like emoji) this will be more than one.
        index += character.length;
      }

      return selector.length - index + whitespace;
    }

    /**
     * Qualifies a CSS selector with a qualifier, which may be another CSS selector
     * or an empty string. For example, given the selector "div.bar" and the
     * qualifier "#foo", this function returns "div#foo.bar".
     * @param {string} selector The selector to qualify.
     * @param {string} qualifier The qualifier with which to qualify the selector.
     * @returns {string} The qualified selector.
     */
    function qualifySelector(selector, qualifier)
    {
      let qualifiedSelector = "";

      let qualifierTargetSelectorIndex = findTargetSelectorIndex(qualifier);
      let [, qualifierType = ""] =
        /^([a-z][a-z-]*)?/i.exec(qualifier.substring(qualifierTargetSelectorIndex));

      for (let sub of splitSelector(selector))
      {
        sub = sub.trim();

        qualifiedSelector += ", ";

        let index = findTargetSelectorIndex(sub);

        // Note that the first group in the regular expression is optional. If it
        // doesn't match (e.g. "#foo::nth-child(1)"), type will be an empty string.
        let [, type = "", rest] =
          /^([a-z][a-z-]*)?\*?(.*)/i.exec(sub.substring(index));

        if (type == qualifierType)
          type = "";

        // If the qualifier ends in a combinator (e.g. "body #foo>"), we put the
        // type and the rest of the selector after the qualifier
        // (e.g. "body #foo>div.bar"); otherwise (e.g. "body #foo") we merge the
        // type into the qualifier (e.g. "body div#foo.bar").
        if (/[\s>+~]$/.test(qualifier))
          qualifiedSelector += sub.substring(0, index) + qualifier + type + rest;
        else
          qualifiedSelector += sub.substring(0, index) + type + qualifier + rest;
      }

      // Remove the initial comma and space.
      return qualifiedSelector.substring(2);
    }

    // exports.qualifySelector = qualifySelector;


    // end of common.js ------------------------------


    // coreUtils.js  ------------------------------

    function desc(properties)
    {
      let descriptor = {};
      let keys = Object.keys(properties);

      for (let key of keys)
        descriptor[key] = Object.getOwnPropertyDescriptor(properties, key);

      return descriptor;
    }
    // exports.desc = desc;

    function extend(cls, properties)
    {
      return Object.create(cls.prototype, desc(properties));
    }
    // exports.extend = extend;

    function findIndex(iterable, callback, thisArg)
    {
      let index = 0;
      for (let item of iterable)
      {
        if (callback.call(thisArg, item))
          return index;

        index++;
      }

      return -1;
    }
    // exports.findIndex = findIndex;

    function indexOf(iterable, searchElement)
    {
      return findIndex(iterable, item => item === searchElement);
    }
    // exports.indexOf = indexOf;
    // end of coreUtils.js ------------------------------
    // elemHideEmulation.js  ------------------------------
    // const {textToRegExp, filterToRegExp, splitSelector,
    //        qualifySelector} = require("../common");
    // const {indexOf} = require("../coreUtils");

    let MIN_INVOCATION_INTERVAL = 3000;
    const MAX_SYNCHRONOUS_PROCESSING_TIME = 50;
    const abpSelectorRegexp = /:-abp-([\w-]+)\(/i;

    let testInfo = null;

    function setTestMode()
    {
      testInfo = {
        lastProcessedElements: new Set()
      };
    }

    // exports.setTestMode = setTestMode;

    function getTestInfo()
    {
      return testInfo;
    }

    // exports.getTestInfo = getTestInfo;

    function getCachedPropertyValue(object, name, defaultValueFunc = () => {})
    {
      let value = object[name];
      if (typeof value == "undefined")
        Object.defineProperty(object, name, {value: value = defaultValueFunc()});
      return value;
    }

    /** Return position of node from parent.
     * @param {Node} node the node to find the position of.
     * @return {number} One-based index like for :nth-child(), or 0 on error.
     */
    function positionInParent(node)
    {
      return indexOf(node.parentNode.children, node) + 1;
    }

    function makeSelector(node, selector = "")
    {
      if (node == null)
        return null;
      if (!node.parentElement)
      {
        let newSelector = ":root";
        if (selector)
          newSelector += " > " + selector;
        return newSelector;
      }
      let idx = positionInParent(node);
      if (idx > 0)
      {
        let newSelector = `${node.tagName}:nth-child(${idx})`;
        if (selector)
          newSelector += " > " + selector;
        return makeSelector(node.parentElement, newSelector);
      }

      return selector;
    }

    function parseSelectorContent(content, startIndex)
    {
      let parens = 1;
      let quote = null;
      let i = startIndex;
      for (; i < content.length; i++)
      {
        let c = content[i];
        if (c == "\\")
        {
          // Ignore escaped characters
          i++;
        }
        else if (quote)
        {
          if (c == quote)
            quote = null;
        }
        else if (c == "'" || c == '"')
          quote = c;
        else if (c == "(")
          parens++;
        else if (c == ")")
        {
          parens--;
          if (parens == 0)
            break;
        }
      }

      if (parens > 0)
        return null;
      return {text: content.substring(startIndex, i), end: i};
    }

    /** Stringified style objects
     * @typedef {Object} StringifiedStyle
     * @property {string} style CSS style represented by a string.
     * @property {string[]} subSelectors selectors the CSS properties apply to.
     */

    /**
     * Produce a string representation of the stylesheet entry.
     * @param {CSSStyleRule} rule the CSS style rule.
     * @return {StringifiedStyle} the stringified style.
     */
    function stringifyStyle(rule)
    {
      let styles = [];
      for (let i = 0; i < rule.style.length; i++)
      {
        let property = rule.style.item(i);
        let value = rule.style.getPropertyValue(property);
        let priority = rule.style.getPropertyPriority(property);
        styles.push(`${property}: ${value}${priority ? " !" + priority : ""};`);
      }
      styles.sort();
      return {
        style: styles.join(" "),
        subSelectors: splitSelector(rule.selectorText)
      };
    }

    let scopeSupported = null;

    function tryQuerySelector(subtree, selector, all)
    {
      let elements = null;
      try
      {
        elements = all ? subtree.querySelectorAll(selector) :
          subtree.querySelector(selector);
        scopeSupported = true;
      }
      catch (e)
      {
        // Edge doesn't support ":scope"
        scopeSupported = false;
      }
      return elements;
    }

    /**
     * Query selector. If it is relative, will try :scope.
     * @param {Node} subtree the element to query selector
     * @param {string} selector the selector to query
     * @param {bool} [all=false] true to perform querySelectorAll()
     * @returns {?(Node|NodeList)} result of the query. null in case of error.
     */
    function scopedQuerySelector(subtree, selector, all)
    {
      if (selector[0] == ">")
      {
        selector = ":scope" + selector;
        if (scopeSupported)
        {
          return all ? subtree.querySelectorAll(selector) :
            subtree.querySelector(selector);
        }
        if (scopeSupported == null)
          return tryQuerySelector(subtree, selector, all);
        return null;
      }
      return all ? subtree.querySelectorAll(selector) :
        subtree.querySelector(selector);
    }

    function scopedQuerySelectorAll(subtree, selector)
    {
      return scopedQuerySelector(subtree, selector, true);
    }

    const regexpRegexp = /^\/(.*)\/([imu]*)$/;

    /**
     * Make a regular expression from a text argument. If it can be parsed as a
     * regular expression, parse it and the flags.
     * @param {string} text the text argument.
     * @return {?RegExp} a RegExp object or null in case of error.
     */
    function makeRegExpParameter(text)
    {
      let [, pattern, flags] =
          regexpRegexp.exec(text) || [null, textToRegExp(text)];

      try
      {
        return new RegExp(pattern, flags);
      }
      catch (e)
      {
      }
      return null;
    }

    function* evaluate(chain, index, prefix, subtree, styles, targets)
    {
      if (index >= chain.length)
      {
        yield prefix;
        return;
      }
      for (let [selector, element] of
           chain[index].getSelectors(prefix, subtree, styles, targets))
      {
        if (selector == null)
          yield null;
        else
          yield* evaluate(chain, index + 1, selector, element, styles, targets);
      }
      // Just in case the getSelectors() generator above had to run some heavy
      // document.querySelectorAll() call which didn't produce any results, make
      // sure there is at least one point where execution can pause.
      yield null;
    }

    class PlainSelector
    {
      constructor(selector)
      {
        this._selector = selector;
        this.maybeDependsOnAttributes = /[#.]|\[.+\]/.test(selector);
        this.dependsOnDOM = this.maybeDependsOnAttributes;
        this.maybeContainsSiblingCombinators = /[~+]/.test(selector);
      }

      /**
       * Generator function returning a pair of selector
       * string and subtree.
       * @param {string} prefix the prefix for the selector.
       * @param {Node} subtree the subtree we work on.
       * @param {StringifiedStyle[]} styles the stringified style objects.
       * @param {Node[]} [targets] the nodes we are interested in.
       */
      *getSelectors(prefix, subtree, styles, targets)
      {
        yield [prefix + this._selector, subtree];
      }
    }

    const incompletePrefixRegexp = /[\s>+~]$/;

    class HasSelector
    {
      constructor(selectors)
      {
        this.dependsOnDOM = true;

        this._innerSelectors = selectors;
      }

      get dependsOnStyles()
      {
        return this._innerSelectors.some(selector => selector.dependsOnStyles);
      }

      get dependsOnCharacterData()
      {
        return this._innerSelectors.some(
          selector => selector.dependsOnCharacterData
        );
      }

      get maybeDependsOnAttributes()
      {
        return this._innerSelectors.some(
          selector => selector.maybeDependsOnAttributes
        );
      }

      *getSelectors(prefix, subtree, styles, targets)
      {
        for (let element of this.getElements(prefix, subtree, styles, targets))
          yield [makeSelector(element), element];
      }

      /**
       * Generator function returning selected elements.
       * @param {string} prefix the prefix for the selector.
       * @param {Node} subtree the subtree we work on.
       * @param {StringifiedStyle[]} styles the stringified style objects.
       * @param {Node[]} [targets] the nodes we are interested in.
       */
      *getElements(prefix, subtree, styles, targets)
      {
        let actualPrefix = (!prefix || incompletePrefixRegexp.test(prefix)) ?
            prefix + "*" : prefix;
        let elements = scopedQuerySelectorAll(subtree, actualPrefix);
        if (elements)
        {
          for (let element of elements)
          {
            // If the element is neither an ancestor nor a descendant of one of the
            // targets, we can skip it.
            if (targets && !targets.some(target => element.contains(target) ||
                                                   target.contains(element)))
            {
              yield null;
              continue;
            }

            let iter = evaluate(this._innerSelectors, 0, "", element, styles,
                                targets);
            for (let selector of iter)
            {
              if (selector == null)
                yield null;
              else if (scopedQuerySelector(element, selector))
                yield element;
            }
            yield null;

            if (testInfo)
              testInfo.lastProcessedElements.add(element);
          }
        }
      }
    }

    class ContainsSelector
    {
      constructor(textContent)
      {
        this.dependsOnDOM = true;
        this.dependsOnCharacterData = true;

        this._regexp = makeRegExpParameter(textContent);
      }

      *getSelectors(prefix, subtree, styles, targets)
      {
        for (let element of this.getElements(prefix, subtree, styles, targets))
          yield [makeSelector(element), subtree];
      }

      *getElements(prefix, subtree, styles, targets)
      {
        let actualPrefix = (!prefix || incompletePrefixRegexp.test(prefix)) ?
            prefix + "*" : prefix;

        let elements = scopedQuerySelectorAll(subtree, actualPrefix);

        if (elements)
        {
          let lastRoot = null;
          for (let element of elements)
          {
            // For a filter like div:-abp-contains(Hello) and a subtree like
            // <div id="a"><div id="b"><div id="c">Hello</div></div></div>
            // we're only interested in div#a
            if (lastRoot && lastRoot.contains(element))
            {
              yield null;
              continue;
            }

            lastRoot = element;

            if (targets && !targets.some(target => element.contains(target) ||
                                                   target.contains(element)))
            {
              yield null;
              continue;
            }

            if (this._regexp && this._regexp.test(element.textContent))
              yield element;
            else
              yield null;

            if (testInfo)
              testInfo.lastProcessedElements.add(element);
          }
        }
      }
    }

    class PropsSelector
    {
      constructor(propertyExpression)
      {
        this.dependsOnStyles = true;
        this.dependsOnDOM = true;

        let regexpString;
        if (propertyExpression.length >= 2 && propertyExpression[0] == "/" &&
            propertyExpression[propertyExpression.length - 1] == "/")
        {
          regexpString = propertyExpression.slice(1, -1);
        }
        else
          regexpString = filterToRegExp(propertyExpression);

        this._regexp = new RegExp(regexpString, "i");
      }

      *findPropsSelectors(styles, prefix, regexp)
      {
        for (let style of styles)
          if (regexp.test(style.style))
            for (let subSelector of style.subSelectors)
            {
              if (subSelector.startsWith("*") &&
                  !incompletePrefixRegexp.test(prefix))
              {
                subSelector = subSelector.substring(1);
              }
              let idx = subSelector.lastIndexOf("::");
              if (idx != -1)
                subSelector = subSelector.substring(0, idx);
              yield qualifySelector(subSelector, prefix);
            }
      }

      *getSelectors(prefix, subtree, styles, targets)
      {
        for (let selector of this.findPropsSelectors(styles, prefix, this._regexp))
          yield [selector, subtree];
      }
    }

    class Pattern
    {
      constructor(selectors, text)
      {
        this.selectors = selectors;
        this.text = text;
      }

      get dependsOnStyles()
      {
        return getCachedPropertyValue(
          this, "_dependsOnStyles",
          () => this.selectors.some(selector => selector.dependsOnStyles)
        );
      }

      get dependsOnDOM()
      {
        return getCachedPropertyValue(
          this, "_dependsOnDOM",
          () => this.selectors.some(selector => selector.dependsOnDOM)
        );
      }

      get dependsOnStylesAndDOM()
      {
        return getCachedPropertyValue(
          this, "_dependsOnStylesAndDOM",
          () => this.selectors.some(selector => selector.dependsOnStyles &&
                                                selector.dependsOnDOM)
        );
      }

      get maybeDependsOnAttributes()
      {
        // Observe changes to attributes if either there's a plain selector that
        // looks like an ID selector, class selector, or attribute selector in one
        // of the patterns (e.g. "a[href='https://example.com/']")
        // or there's a properties selector nested inside a has selector
        // (e.g. "div:-abp-has(:-abp-properties(color: blue))")
        return getCachedPropertyValue(
          this, "_maybeDependsOnAttributes",
          () => this.selectors.some(
                  selector => selector.maybeDependsOnAttributes ||
                              (selector instanceof HasSelector &&
                               selector.dependsOnStyles)
                )
        );
      }

      get dependsOnCharacterData()
      {
        // Observe changes to character data only if there's a contains selector in
        // one of the patterns.
        return getCachedPropertyValue(
          this, "_dependsOnCharacterData",
          () => this.selectors.some(selector => selector.dependsOnCharacterData)
        );
      }

      get maybeContainsSiblingCombinators()
      {
        return getCachedPropertyValue(
          this, "_maybeContainsSiblingCombinators",
          () => this.selectors.some(selector =>
                                    selector.maybeContainsSiblingCombinators)
        );
      }

      matchesMutationTypes(mutationTypes)
      {
        let mutationTypeMatchMap = getCachedPropertyValue(
          this, "_mutationTypeMatchMap",
          () => new Map([
            // All types of DOM-dependent patterns are affected by mutations of
            // type "childList".
            ["childList", true],
            ["attributes", this.maybeDependsOnAttributes],
            ["characterData", this.dependsOnCharacterData]
          ])
        );

        for (let mutationType of mutationTypes)
        {
          if (mutationTypeMatchMap.get(mutationType))
            return true;
        }

        return false;
      }
    }

    function extractMutationTypes(mutations)
    {
      let types = new Set();

      for (let mutation of mutations)
      {
        types.add(mutation.type);

        // There are only 3 types of mutations: "attributes", "characterData", and
        // "childList".
        if (types.size == 3)
          break;
      }

      return types;
    }

    function extractMutationTargets(mutations)
    {
      if (!mutations)
        return null;

      let targets = new Set();

      for (let mutation of mutations)
      {
        if (mutation.type == "childList")
        {
          // When new nodes are added, we're interested in the added nodes rather
          // than the parent.
          for (let node of mutation.addedNodes)
            targets.add(node);
        }
        else
        {
          targets.add(mutation.target);
        }
      }

      return [...targets];
    }

    function filterPatterns(patterns, {stylesheets, mutations})
    {
      if (!stylesheets && !mutations)
        return patterns.slice();

      let mutationTypes = mutations ? extractMutationTypes(mutations) : null;

      return patterns.filter(
        pattern => (stylesheets && pattern.dependsOnStyles) ||
                   (mutations && pattern.dependsOnDOM &&
                    pattern.matchesMutationTypes(mutationTypes))
      );
    }

    function shouldObserveAttributes(patterns)
    {
      return patterns.some(pattern => pattern.maybeDependsOnAttributes);
    }

    function shouldObserveCharacterData(patterns)
    {
      return patterns.some(pattern => pattern.dependsOnCharacterData);
    }

    class ElemHideEmulation
    {
      constructor(hideElemsFunc)
      {
        this._filteringInProgress = false;
        this._lastInvocation = -MIN_INVOCATION_INTERVAL;
        this._scheduledProcessing = null;

        this.document = document;
        this.hideElemsFunc = hideElemsFunc;
        this.observer = new MutationObserver(this.observe.bind(this));
      }

      isSameOrigin(stylesheet)
      {
        try
        {
          return new URL(stylesheet.href).origin == this.document.location.origin;
        }
        catch (e)
        {
          // Invalid URL, assume that it is first-party.
          return true;
        }
      }

      /** Parse the selector
       * @param {string} selector the selector to parse
       * @return {Array} selectors is an array of objects,
       * or null in case of errors.
       */
      parseSelector(selector)
      {
        if (selector.length == 0)
          return [];

        let match = abpSelectorRegexp.exec(selector);
        if (!match)
          return [new PlainSelector(selector)];

        let selectors = [];
        if (match.index > 0)
          selectors.push(new PlainSelector(selector.substring(0, match.index)));

        let startIndex = match.index + match[0].length;
        let content = parseSelectorContent(selector, startIndex);
        if (!content)
        {
          console.error(new SyntaxError("Failed to parse Adblock Plus " +
                                        `selector ${selector} ` +
                                        "due to unmatched parentheses."));
          return null;
        }
        if (match[1] == "properties")
          selectors.push(new PropsSelector(content.text));
        else if (match[1] == "has")
        {
          let hasSelectors = this.parseSelector(content.text);
          if (hasSelectors == null)
            return null;
          selectors.push(new HasSelector(hasSelectors));
        }
        else if (match[1] == "contains")
          selectors.push(new ContainsSelector(content.text));
        else
        {
          // this is an error, can't parse selector.
          console.error(new SyntaxError("Failed to parse Adblock Plus " +
                                        `selector ${selector}, invalid ` +
                                        `pseudo-class :-abp-${match[1]}().`));
          return null;
        }

        let suffix = this.parseSelector(selector.substring(content.end + 1));
        if (suffix == null)
          return null;

        selectors.push(...suffix);

        if (selectors.length == 1 && selectors[0] instanceof ContainsSelector)
        {
          console.error(new SyntaxError("Failed to parse Adblock Plus " +
                                        `selector ${selector}, can't ` +
                                        "have a lonely :-abp-contains()."));
          return null;
        }
        return selectors;
      }

      /**
       * Processes the current document and applies all rules to it.
       * @param {CSSStyleSheet[]} [stylesheets]
       *    The list of new stylesheets that have been added to the document and
       *    made reprocessing necessary. This parameter shouldn't be passed in for
       *    the initial processing, all of document's stylesheets will be considered
       *    then and all rules, including the ones not dependent on styles.
       * @param {MutationRecord[]} [mutations]
       *    The list of DOM mutations that have been applied to the document and
       *    made reprocessing necessary. This parameter shouldn't be passed in for
       *    the initial processing, the entire document will be considered
       *    then and all rules, including the ones not dependent on the DOM.
       * @param {function} [done]
       *    Callback to call when done.
       */
      _addSelectors(stylesheets, mutations, done)
      {
        if (testInfo)
          testInfo.lastProcessedElements.clear();

        let patterns = filterPatterns(this.patterns, {stylesheets, mutations});

        let elements = [];
        let elementFilters = [];

        let cssStyles = [];

        // If neither any style sheets nor any DOM mutations have been specified,
        // do full processing.
        if (!stylesheets && !mutations)
          stylesheets = this.document.styleSheets;

        // If there are any DOM mutations and any of the patterns depends on both
        // style sheets and the DOM (e.g. -abp-has(-abp-properties)), find all the
        // rules in every style sheet in the document, because we need to run
        // querySelectorAll afterwards. On the other hand, if we only have patterns
        // that depend on either styles or DOM both not both (e.g. -abp-contains),
        // we can skip this part.
        if (mutations && patterns.some(pattern => pattern.dependsOnStylesAndDOM))
          stylesheets = this.document.styleSheets;

        for (let stylesheet of stylesheets || [])
        {
          // Explicitly ignore third-party stylesheets to ensure consistent behavior
          // between Firefox and Chrome.
          if (!this.isSameOrigin(stylesheet))
            continue;

          let rules;
          try
          {
            rules = stylesheet.cssRules;
          }
          catch (e)
          {
            // On Firefox, there is a chance that an InvalidAccessError
            // get thrown when accessing cssRules. Just skip the stylesheet
            // in that case.
            // See https://searchfox.org/mozilla-central/rev/f65d7528e34ef1a7665b4a1a7b7cdb1388fcd3aa/layout/style/StyleSheet.cpp#699
            continue;
          }

          if (!rules)
            continue;

          for (let rule of rules)
          {
            if (rule.type != rule.STYLE_RULE)
              continue;

            cssStyles.push(stringifyStyle(rule));
          }
        }

        let targets = extractMutationTargets(mutations);

        let pattern = null;
        let generator = null;

        let processPatterns = () =>
        {
          let cycleStart = performance.now();

          if (!pattern)
          {
            if (!patterns.length)
            {
              if (elements.length > 0)
                this.hideElemsFunc(elements, elementFilters);
              if (typeof done == "function")
                done();
              return;
            }

            pattern = patterns.shift();

            let evaluationTargets = targets;

            // If the pattern appears to contain any sibling combinators, we can't
            // easily optimize based on the mutation targets. Since this is a
            // special case, skip the optimization. By setting it to null here we
            // make sure we process the entire DOM.
            if (pattern.maybeContainsSiblingCombinators)
              evaluationTargets = null;

            generator = evaluate(pattern.selectors, 0, "",
                                 this.document, cssStyles, evaluationTargets);
          }
          for (let selector of generator)
          {
            if (selector != null)
            {
              for (let element of this.document.querySelectorAll(selector))
              {
                elements.push(element);
                elementFilters.push(pattern.text);
              }
            }
            if (performance.now() - cycleStart > MAX_SYNCHRONOUS_PROCESSING_TIME)
            {
              setTimeout(processPatterns, 0);
              return;
            }
          }
          pattern = null;
          return processPatterns();
        };

        processPatterns();
      }

      // This property is only used in the tests
      // to shorten the invocation interval
      get MIN_INVOCATION_INTERVAL()
      {
        return MIN_INVOCATION_INTERVAL;
      }

      set MIN_INVOCATION_INTERVAL(interval)
      {
        MIN_INVOCATION_INTERVAL = interval;
      }

      /**
       * Re-run filtering either immediately or queued.
       * @param {CSSStyleSheet[]} [stylesheets]
       *    new stylesheets to be processed. This parameter should be omitted
       *    for full reprocessing.
       * @param {MutationRecord[]} [mutations]
       *    new DOM mutations to be processed. This parameter should be omitted
       *    for full reprocessing.
       */
      queueFiltering(stylesheets, mutations)
      {
        let completion = () =>
        {
          this._lastInvocation = performance.now();
          this._filteringInProgress = false;
          if (this._scheduledProcessing)
          {
            let params = Object.assign({}, this._scheduledProcessing);
            this._scheduledProcessing = null;
            this.queueFiltering(params.stylesheets, params.mutations);
          }
        };

        if (this._scheduledProcessing)
        {
          if (!stylesheets && !mutations)
          {
            this._scheduledProcessing = {};
          }
          else if (this._scheduledProcessing.stylesheets ||
                   this._scheduledProcessing.mutations)
          {
            if (stylesheets)
            {
              if (!this._scheduledProcessing.stylesheets)
                this._scheduledProcessing.stylesheets = [];
              this._scheduledProcessing.stylesheets.push(...stylesheets);
            }
            if (mutations)
            {
              if (!this._scheduledProcessing.mutations)
                this._scheduledProcessing.mutations = [];
              this._scheduledProcessing.mutations.push(...mutations);
            }
          }
        }
        else if (this._filteringInProgress)
        {
          this._scheduledProcessing = {stylesheets, mutations};
        }
        else if (performance.now() - this._lastInvocation < MIN_INVOCATION_INTERVAL)
        {
          this._scheduledProcessing = {stylesheets, mutations};
          setTimeout(() =>
          {
            let params = Object.assign({}, this._scheduledProcessing);
            this._filteringInProgress = true;
            this._scheduledProcessing = null;
            this._addSelectors(params.stylesheets, params.mutations, completion);
          },
          MIN_INVOCATION_INTERVAL - (performance.now() - this._lastInvocation));
        }
        else if (this.document.readyState == "loading")
        {
          this._scheduledProcessing = {stylesheets, mutations};
          let handler = () =>
          {
            this.document.removeEventListener("DOMContentLoaded", handler);
            let params = Object.assign({}, this._scheduledProcessing);
            this._filteringInProgress = true;
            this._scheduledProcessing = null;
            this._addSelectors(params.stylesheets, params.mutations, completion);
          };
          this.document.addEventListener("DOMContentLoaded", handler);
        }
        else
        {
          this._filteringInProgress = true;
          this._addSelectors(stylesheets, mutations, completion);
        }
      }

      onLoad(event)
      {
        let stylesheet = event.target.sheet;
        if (stylesheet)
          this.queueFiltering([stylesheet]);
      }

      observe(mutations)
      {
        if (testInfo)
        {
          // In test mode, filter out any mutations likely done by us
          // (i.e. style="display: none !important"). This makes it easier to
          // observe how the code responds to DOM mutations.
          mutations = mutations.filter(
            ({type, attributeName, target: {style: newValue}, oldValue}) =>
            !(type == "attributes" && attributeName == "style" &&
              newValue.display == "none" && oldValue.display != "none")
          );

          if (mutations.length == 0)
            return;
        }

        this.queueFiltering(null, mutations);
      }

      apply(patterns)
      {
        this.patterns = [];
        for (let pattern of patterns)
        {
          let selectors = this.parseSelector(pattern.selector);
          if (selectors != null && selectors.length > 0)
            this.patterns.push(new Pattern(selectors, pattern.text));
        }

        if (this.patterns.length > 0)
        {
          this.queueFiltering();
          this.observer.observe(
            this.document,
            {
              childList: true,
              attributes: shouldObserveAttributes(this.patterns),
              characterData: shouldObserveCharacterData(this.patterns),
              subtree: true
            }
          );
          this.document.addEventListener("load", this.onLoad.bind(this), true);
        }
      }
    }

    // exports.ElemHideEmulation = ElemHideEmulation;
    // end of elemHideEmulation.js  ------------------------------
    // elemHidingEmulatedPatterns array definition is generated in adblock_bridge.cc
    console.log('starting injecting eh emu css rules for ' + document.location.href);
    let elemHidingEmulatedPatterns = XWebViewApi.getElementHidingSelectors(XWebViewApi.ADBLOCK_OPTION_HIDING_SELECTORS_NORMAL);

    // adopted from applyElemHideEmulation function in:
    // https://gitlab.com/eyeo/adblockplus/adblockpluscore/blob/master/test/browser/elemHideEmulation.js

    let elemHideEmulation = new ElemHideEmulation(elems => {
        for (let elem of elems) {
            elem.style.display = "none";
        }
    });

    for (var i = 0; i < elemHidingEmulatedPatterns.length; ++i) {
        elemHideEmulation.apply(XWebViewApi.parse(elemHidingEmulatedPatterns[i], []));
    }
})();


// gm api implement file
// detail: https://www.tampermonkey.net/documentation.php
(function() {
    window.XGM = {
        storagePrefix: function(gmInfo, key) {
            return "gm_" + gmInfo.uuid + "_" + (key == null ? "" : key);
        },

        addStyle : function (gmInfo, css) {
            var head = document.getElementsByTagName('head')[0];
            if (head) {
                var style = document.createElement('style');
                style.setAttribute('type', 'text/css');
                style.textContent = css;
                head.appendChild(style);
                return style;
            }

            return null;
        },

        addElement : function (gmInfo, ...args) { // (tag_name, attributes) or (parent_node, tag_name, attributes)
            var node = null, tag = null, attrs = null;

            if (args.length == 2) {
                node = document.head;
                tag = args[0];
                attrs = args[1];
            } else if (args.length == 3) {
                node = args[0];
                tag = args[1];
                attrs = args[2];
            }

            if (node != null && tag != null && attrs != null) {
                var c = document.createElement(tag);
                if (c != null) {
                    for (var key in attrs) {
                        if (key.toLowerCase() === 'textcontent') {
                            c.textContent = attrs[key];
                        } else {
                            c.setAttribute(key, attrs[key]);
                        }
                    }
                    node.appendChild(c);
                }
                return c;
            }
        },

        deleteValue : function (gmInfo, name) {
            var key = window.XGM.storagePrefix(gmInfo, name);
            XWebViewApi.localStorage.removeItem(key);
        },

        listValues : function (gmInfo) {
            var prefix = window.XGM.storagePrefix(gmInfo);
            var prefixLen = prefix.length;
            var values = [];

            var size = XWebViewApi.localStorage.size();
            for (var i = 0; i < size; i++) {
                var k = XWebViewApi.localStorage.key(i);
                if (k.substr(0, prefixLen) === prefix) {
                    values.push(k.substr(prefixLen));
                }
            }

            return values;
        },

        addValueChangeListener : function (gmInfo, name, callback) { // callback: function(name, old_value, new_value, remote) {}
            var item = {
                id : 'gm_' + gmInfo.uuid + new Date().getTime(),
                uuid : gmInfo.uuid,
                key : name,
                cb : callback
            }

            if (window.XGM.valueCbs == null) {
                window.XGM.valueCbs = [];
            }

            window.XGM.valueCbs.push(item);
            return item.id;
        },

        removeValueChangeListener : function (gmInfo, id) {
            if (window.XGM.valueCbs != null) {
                for (var i = 0; i < window.XGM.valueCbs.length; ++i) {
                    var item = window.XGM.valueCbs[i];
                    if (item.id == id) {
                        window.XGM.valueCbs.splice(i, 1);
                        break;
                    }
                }
            }
        },

        fireValueChangeListener: function(gmInfo, aKey, old_value, new_value) {
            if (window.XGM.valueCbs != null) {
                for (var i = 0; i < window.XGM.valueCbs.length; ++i) {
                    var item = window.XGM.valueCbs[i];
                    if (item.key === aKey) {
                        item.cb(aKey, old_value, new_value, !(gmInfo.uuid === item.uuid));
                    }
                }
            }
        },

        setValue : function (gmInfo, name, value) {
            var key = window.XGM.storagePrefix(gmInfo, name);
            var val = XWebViewApi.localStorage.getItem(key);
            if (null === val) {
                val = JSON.stringify('');
            }

            XWebViewApi.localStorage.setItem(key, JSON.stringify(value));
            window.XGM.fireValueChangeListener(gmInfo, name, JSON.parse(val), value);
        },

        getValue : function (gmInfo, name, defaultValue) {
            var key = window.XGM.storagePrefix(gmInfo, name);
            var val = XWebViewApi.localStorage.getItem(key);

            if (null === val && 'undefined' != typeof defaultValue) {
                return defaultValue;
            }

            return JSON.parse(val);
        },

        log : function (gmInfo, message) {
            console.log(message);
        },

        getResourceText : function (gmInfo, name) {
            if (XWebViewApi != null && XWebViewApi.call != null) {
                return XWebViewApi.call('getResourceText', {id: gmInfo.uuid, res: name}, 'browser', 'gm');
            }
            return '';
        },

        getResourceURL : function (gmInfo, name) {
            if (XWebViewApi != null && XWebViewApi.call != null) {
                return XWebViewApi.call('getResourceURL', {id: gmInfo.uuid, res: name}, 'browser', 'gm');
            }

            return '';
        },

        registerMenuCommand : function (gmInfo, name, fn, accessKey) {
            if (window.__GM_GC == null) {
                window.__GM_GC = [];
            }

            var menuCmdId = 'menu:gm_' + XWebViewApi.hashCode(name) + '@' + gmInfo.uuid;
            var cbn = 'window.__GM_GC["' + menuCmdId + '"]';

            window.__GM_GC[menuCmdId] = function (d) {
                fn();
            }

            if (XWebViewApi != null && XWebViewApi.registerMenuCommand != null) {
                XWebViewApi.registerMenuCommand('menu.bar.top.gm', menuCmdId, name, cbn);
            }

            return menuCmdId;
        },

        unregisterMenuCommand : function (gmInfo, menuCmdId) {
            if (window.__GM_GC != null) {
                window.__GM_GC[menuCmdId] = null;

                if (XWebViewApi != null && XWebViewApi.registerMenuCommand != null) {
                    XWebViewApi.unregisterMenuCommand('menu.bar.top.gm', menuCmdId);
                }
            }
        },

        openInTab : function (gmInfo, href, extra) { // (url, options) or (url, loadInBackground)
            if (XWebViewApi != null && XWebViewApi.call != null) {
                if (typeof extra === 'boolean') {
                    XWebViewApi.call('openInTab', {url: href, background: extra}, 'browser', 'gm');
                } else {
                    XWebViewApi.call('openInTab', {url: href, background: false}, 'browser', 'gm');
                }
            } else {
                window.location.href = url;
                //window.open(url);
            }
        },

        xmlhttpRequest : function (gmInfo, aOpts) {
            if (XWebViewApi == null || XWebViewApi.ajax == null) {
                window.XGM.xmlhttpRequest2(gmInfo, aOpts);
                return;
            }

            if (false && aOpts.responseType != null && aOpts.responseType.indexOf('blob') >= 0) {
                window.XGM.xmlhttpRequest2(gmInfo, aOpts);
                return;
            }

            var responseState = {
                responseText : null,
                responseXML : null,
                response : null,
                readyState : 0,
                responseHeaders : null,
                responseType : '',
                status : null,
                statusText : null,
                finalUrl : null,
                loaded : 0,
                total : -1,
                lengthComputable : false
            };

            var cbId = 'ajax:cb_' + new Date().getTime() + '@' + gmInfo.uuid;
            var cbn = 'window.__GM_HR_GC["' + cbId + '"]';
            if (window.__GM_HR_GC == null) {
                window.__GM_HR_GC = [];
            }
            window.__GM_HR_GC[cbId] = function (params) {
                var p = JSON.parse(params); // {"event":"DONE","loaded":2381,"code":200,"message":"OK","body":"xxx", "headers":{}}

                responseState.loaded = Number(p.loaded);
                responseState.status = Number(p.code);
                responseState.statusText = p.message;
                responseState.response = p.body;
                responseState.responseText = p.body;
                responseState.responseHeaders = p.headers;

                //UNSENT = 0; // initial state
                //OPENED = 1; // open called
                //HEADERS_RECEIVED = 2; // response headers received
                //LOADING = 3; // response is loading (a data packet is received)
                //DONE = 4; // request complete
                if ('OPENED' === p.event) {
                    responseState.readyState = 1;
                    if (aOpts['onreadystatechange'] != null) {
                        aOpts['onreadystatechange'](responseState);
                    }
                } else if ('HEADERS_RECEIVED' === p.event) {
                    if (responseState.readyState != 2) {
                        responseState.readyState = 2;
                        if (aOpts['onreadystatechange'] != null) {
                            aOpts['onreadystatechange'](responseState);
                        }
                    }
                } else if ('LOADING' === p.event) {
                    if (responseState.readyState != 3) {
                        responseState.readyState = 3;
                        if (aOpts['onreadystatechange'] != null) {
                            aOpts['onreadystatechange'](responseState);
                        }
                    }

                    if (responseState.total == -1) {
                        responseState.total = Number(p.headers['Content-Length']);
                        responseState.lengthComputable = responseState.total > 0;
                    }

                    if (aOpts['onprogress'] != null) {
                        aOpts['onprogress'](responseState);
                    }
                } else if ('DONE' === p.event) {
                    window.__GM_HR_GC[cbId] = null;

                    if (responseState.readyState != 4) {
                        responseState.readyState = 4;
                        if (aOpts['onreadystatechange'] != null) {
                            aOpts['onreadystatechange'](responseState);
                        }
                    }

                    if (responseState.status < 0) {
                        if (aOpts['onerror'] != null) {
                            aOpts['onerror'](responseState);
                        }
                    } else {
                        try {
                            var contentType = p.headers['Content-Type'];
                            if (aOpts.responseType != null && aOpts.responseType.indexOf('json') >= 0) {
                                responseState.responseType = 'json';
                                responseState.response = JSON.parse(responseState.response);
                            } else if (aOpts.responseType != null && aOpts.responseType.indexOf('document') >= 0) {
                                var mime = 'text/html';
                                if (contentType != null) {
                                    if (contentType.indexOf('text/xml') >= 0) {
                                        mime = 'text/xml';
                                    } else if (contentType.indexOf('application/xml') >= 0) {
                                        mime = 'application/xml';
                                    } else if (contentType.indexOf('application/xhtml+xml') >= 0) {
                                        mime = 'application/xhtml+xml';
                                    } else if (contentType.indexOf('image/svg+xml') >= 0) {
                                        mime = 'image/svg+xml';
                                    }
                                }

                                responseState.responseType = 'document';
                                responseState.response = new DOMParser().parseFromString(responseState.response, mime);
                            } else if (contentType != null && contentType.indexOf('json') >= 0) {
                                responseState.responseType = 'json';
                                responseState.response = JSON.parse(responseState.response);
                            }
                        } catch (e) {
                            console.error(e);
                        }

                        if (aOpts['onload'] != null) {
                            try {
                                aOpts['onload'](responseState);
                            } catch (e) {
                                if (responseState.responseText == null) {
                                    responseState.responseText = '';
                                }

                                aOpts['onload'](responseState);
                            }
                        }
                    }
                }
            };

            if (aOpts.headers == null) {
                aOpts.headers = {};
            }

            if (aOpts.overrideMimeType) {
                aOpts.headers['Content-Type'] = aOpts.overrideMimeType;
            }

            if (aOpts.headers['Cookie'] == null) {
                aOpts.headers['Cookie'] = document.cookie;
            }

            if (aOpts.headers['User-Agent'] == null) {
                aOpts.headers['User-Agent'] = navigator.userAgent;
            }

            if (aOpts.headers['Referer'] == null) {
                aOpts.headers['Referer'] = window.location.href;
            }

            XWebViewApi.ajax(aOpts.synchronous, aOpts.url, aOpts.method, aOpts.headers, aOpts.data, cbn);
        },

        xmlhttpRequest2 : function (gmInfo, aOpts) {
            var setupRequestEvent = function (aOpts, aReq, aEventName) {
                if (!aOpts['on' + aEventName]) {
                    return;
                }

                aReq.addEventListener(aEventName, function (aEvent) {
                    var responseState = {
                        responseText : aReq.responseText,
                        responseXML : aReq.responseXML,
                        response : aOpts.responseType === 'json' && aReq.response != null ? JSON.parse(aReq.response) : aReq.response,
                        readyState : aReq.readyState,
                        responseHeaders : null,
                        status : null,
                        statusText : null,
                        finalUrl : null
                    };

                    switch (aEventName) {
                    case "progress":
                        responseState.lengthComputable = aEvent.lengthComputable;
                        responseState.loaded = aEvent.loaded;
                        responseState.total = aEvent.total;
                        break;
                    case "error":
                        break;
                    default:
                        if (4 != aReq.readyState)
                            break;
                        responseState.responseHeaders = aReq.getAllResponseHeaders();
                        responseState.status = aReq.status;
                        responseState.statusText = aReq.statusText;
                        break;
                    }

                    aOpts['on' + aEventName](responseState);
                });
            }

            var req = new XMLHttpRequest();
            setupRequestEvent(aOpts, req, 'abort');
            setupRequestEvent(aOpts, req, 'error');
            setupRequestEvent(aOpts, req, 'load');
            setupRequestEvent(aOpts, req, 'progress');
            setupRequestEvent(aOpts, req, 'readystatechange');

            req.open(aOpts.method, aOpts.url, !aOpts.synchronous, aOpts.user || '', aOpts.password || '');

            if (aOpts.overrideMimeType) {
                req.overrideMimeType(aOpts.overrideMimeType);
            }

            if (aOpts.headers) {
                for (let prop in aOpts.headers) {
                    if (Object.prototype.hasOwnProperty.call(aOpts.headers, prop)) {
                        try {
                            req.setRequestHeader(prop, aOpts.headers[prop]);
                        } catch (e) {
                            console.log("req.setRequestHeader error:" + e + ", prop:" + prop);
                        }
                    }
                }
            }

            var body = aOpts.data ? aOpts.data : null;

            if (aOpts.binary) {
                return req.sendAsBinary(body);
            } else {
                return req.send(body);
            }
        },

        download : function (gmInfo, arg1, arg2) { //(details) or (url, name)
            var url = arg1;

            if (typeof arg1 === 'object') {
                url = arg1.url;
            }

            if (url != null && url.length > 0 && url.startsWith('blob:')) {
                 var xhr = new XMLHttpRequest();
                    xhr.open('GET', url, true);
                    //xhr.setRequestHeader('Content-type', 'application/zip;charset=UTF-8');
                    xhr.responseType = 'blob';
                    xhr.onload = function(e) {
                        if (xhr.status == 200) {
                            var reader = new FileReader();
                            reader.readAsDataURL(xhr.response);
                            reader.onloadend = function() {
                                if (typeof arg1 === 'string') {
                                    window.XGM.download(gmInfo, reader.result, arg2);
                                } else {
                                    arg1.url = reader.result;
                                    window.XGM.download(gmInfo, arg1, arg2);
                                }
                            };
                            reader.onerror = function() {
                                if (typeof arg1 === 'object') {
                                    if (arg1.onerror != null) {
                                        arg1.onerror();
                                    }
                                }
                            };
                        } else if (typeof arg1 === 'object') {
                            if (arg1.onerror != null) {
                                arg1.onerror();
                            }
                        }
                    };
                    xhr.send();
            } else {
                if (typeof arg1 === 'string') {
                    if (XWebViewApi != null && XWebViewApi.createTask != null) {
                        XWebViewApi.createTask(arg1, arg2, {}, '');
                    } else {
                        window.location.href = arg1;
                    }
                } else {
                    var details = arg1;
                    //details.onerror()
                    //details.headers;
                    //details.name;
                    //details.url;
                    if (details != null) {
                        if (XWebViewApi != null && XWebViewApi.createTask != null) {
                            XWebViewApi.createTask(details.url, details.name, details.headers, '');
                        } else {
                            window.location.href = details.url;
                        }
                    }
                }
            }
        },

        getTab : function (gmInfo, callback) {
            var tid = XWebViewApi.call('getTab', gmInfo.uuid, 'browser', 'gm');
            if (tid == null || tid.length == 0) {
                tid = "default";
            }
            callback({tabId : tid});
        },

        saveTab : function (gmInfo, tab) {},

        getTabs : function (gmInfo, callback) {
            // 获取所有tab对象作为散列与其他脚本实例通信。
            var tabs = XWebViewApi.call('getTabs', gmInfo.uuid, 'browser', 'gm');
            if (tabs != null && tabs.length > 0) {
                tabs = JSON.parse(tabs);
            }

            if (tabs == null || tabs.length <= 0) {
                tabs = [{tabId : "default"}];
            }

            callback(tabs);
        },

        notification : function (gmInfo, ...args) { //(details, ondone) or (text, title, image, onclick)
            //    details 的属性：
            //    text - 通知的问题 如果高亮就 就不需要
            //    title - 通知的标题
            //    image - 图片
            //    highlight - 一个boolean标志，是否高亮tab
            //    silent -  一个boolean 是否播放音乐
            //    timeout - 通知显示的时间  0表示 一直显示
            //    ondone - 通知被关闭时 无论是被点击还是超时 执行的函数
            //    onclick - 点击通知触发的函数
            //    所有参数的作用与其对应的详细信息属性挂件完全相同。
            var details = null;

            if (args.length > 2) {
                details = {};
                details.text = args[0];
                details.title = args[1];
                details.image = args[2];

                if (args.length > 3) {
                    details.onclick = args[3];
                }
            } else if (args.length > 0) {
                details = arg[0];

                if (args.length > 1) {
                    details.ondone = arg[1];
                }
            }

            if (details != null) {
                var id = 'notify:gm_' + XWebViewApi.hashCode(details.title) + '@' + gmInfo.uuid;
                var callback = '';

                if (details.onclick != null) {
                    callback = 'window.__GM_GC["' + id + '"]';
                    window.__GM_GC[id] = function (d) {
                        details.onclick();
                    }
                }

                XWebViewApi.showNotification('app.browser.gm.notify', id, details.title, details.text, details.image, details.timeout, callback);
            }
        },

        setClipboard : function (gmInfo, data, info) {
            //复制数据到粘贴板，参数info可以是对象如{type: 'text', mimetype: 'text/plain'}，或者是一个字符串 text， html
            var aux = document.createElement('input');
            aux.setAttribute('value', data);
            document.body.appendChild(aux);
            aux.select();
            document.execCommand('copy');
            document.body.removeChild(aux);
        },
    };
})();